classdef EvaluationFunctionalSystem < FunctionalSystem
    
    properties
        points
    end
    
    methods
        function obj = EvaluationFunctionalSystem(x)
            if ~isvector(x)
                error('The argument x must be a vector.');
            end
            
            obj.points = reshape(x, 1, length(x));
        end
        
        function y = evaluate(obj, f)
            if ~isa(f, 'Function')
                error('The first argument must be of type function.');
            end
            
            y = f.ofAll(obj.points)';
        end
        
        function y = evaluateFunctionSystem(obj, F)
            if ~isa(F, 'FunctionSystem')
                error('The first argument must be of type function system.');
            end
            
            % y = arrayfun(@(x) F.evaluate(x)', obj.points, 'UniformOutput', false);
            % y = vertcat(y{:});
            % return
            
            %NEU!
            y = F.evaluateAll(obj.points)';
        end
        
        function L = get(obj, i)
            if ~isscalar(i) || (i < 1) || (i > length(obj.points))
                error('The argument N is not a suitable index.');
            end
            
            L = EvaluationFunctional(obj.points(i));
        end
    end
    
end

